declare module 'vuetify/lib' {
  import { Component, DirectiveOptions } from 'vue'
  import { Vuetify } from 'vuetify'
  import { Colors } from 'vuetify/lib/util/colors'

  const Vuetify: Vuetify
  const colors: Colors
  const ClickOutside: DirectiveOptions
  const Intersect: DirectiveOptions
  const Mutate: DirectiveOptions
  const Resize: DirectiveOptions
  const Ripple: DirectiveOptions
  const Scroll: DirectiveOptions
  const Touch: DirectiveOptions
  const VApp: Component
  const VAppBar: Component
  const VAppBarNavIcon: Component
  const VAlert: Component
  const VAutocomplete: Component
  const VAvatar: Component
  const VBadge: Component
  const VBanner: Component
  const VBottomNavigation: Component
  const VBottomSheet: Component
  const VBreadcrumbs: Component
  const VBreadcrumbsItem: Component
  const VBreadcrumbsDivider: Component
  const VBtn: Component
  const VBtnToggle: Component
  const VCalendar: Component
  const VCalendarDaily: Component
  const VCalendarWeekly: Component
  const VCalendarMonthly: Component
  const VCard: Component
  const VCardTitle: Component
  const VCardSubtitle: Component
  const VCardActions: Component
  const VCardText: Component
  const VCarousel: Component
  const VCarouselItem: Component
  const VCheckbox: Component
  const VSimpleCheckbox: Component
  const VChip: Component
  const VChipGroup: Component
  const VColorPicker: Component
  const VColorPickerSwatches: Component
  const VColorPickerCanvas: Component
  const VContent: Component
  const VCombobox: Component
  const VCounter: Component
  const VData: Component
  const VDataIterator: Component
  const VDataFooter: Component
  const VDataTable: Component
  const VEditDialog: Component
  const VTableOverflow: Component
  const VDataTableHeader: Component
  const VSimpleTable: Component
  const VVirtualTable: Component
  const VDatePicker: Component
  const VDatePickerTitle: Component
  const VDatePickerHeader: Component
  const VDatePickerDateTable: Component
  const VDatePickerMonthTable: Component
  const VDatePickerYears: Component
  const VDialog: Component
  const VDivider: Component
  const VExpansionPanels: Component
  const VExpansionPanel: Component
  const VExpansionPanelHeader: Component
  const VExpansionPanelContent: Component
  const VFileInput: Component
  const VFooter: Component
  const VForm: Component
  const VContainer: Component
  const VCol: Component
  const VRow: Component
  const VSpacer: Component
  const VLayout: Component
  const VFlex: Component
  const VHover: Component
  const VIcon: Component
  const VImg: Component
  const VInput: Component
  const VItem: Component
  const VItemGroup: Component
  const VLabel: Component
  const VLazy: Component
  const VListItemActionText: Component
  const VListItemContent: Component
  const VListItemTitle: Component
  const VListItemSubtitle: Component
  const VList: Component
  const VListGroup: Component
  const VListItem: Component
  const VListItemAction: Component
  const VListItemAvatar: Component
  const VListItemIcon: Component
  const VListItemGroup: Component
  const VMenu: Component
  const VMessages: Component
  const VNavigationDrawer: Component
  const VOverflowBtn: Component
  const VOverlay: Component
  const VPagination: Component
  const VSheet: Component
  const VParallax: Component
  const VPicker: Component
  const VProgressCircular: Component
  const VProgressLinear: Component
  const VRadioGroup: Component
  const VRadio: Component
  const VRangeSlider: Component
  const VRating: Component
  const VResponsive: Component
  const VSelect: Component
  const VSkeletonLoader: Component
  const VSlider: Component
  const VSlideGroup: Component
  const VSlideItem: Component
  const VSnackbar: Component
  const VSparkline: Component
  const VSpeedDial: Component
  const VStepper: Component
  const VStepperContent: Component
  const VStepperStep: Component
  const VStepperHeader: Component
  const VStepperItems: Component
  const VSubheader: Component
  const VSwitch: Component
  const VSystemBar: Component
  const VTabs: Component
  const VTab: Component
  const VTabItem: Component
  const VTabsItems: Component
  const VTabsSlider: Component
  const VTextarea: Component
  const VTextField: Component
  const VTimeline: Component
  const VTimelineItem: Component
  const VTimePicker: Component
  const VTimePickerClock: Component
  const VTimePickerTitle: Component
  const VToolbar: Component
  const VToolbarItems: Component
  const VToolbarTitle: Component
  const VTooltip: Component
  const VTreeview: Component
  const VTreeviewNode: Component
  const VWindow: Component
  const VWindowItem: Component
  const VCarouselTransition: Component
  const VCarouselReverseTransition: Component
  const VTabTransition: Component
  const VTabReverseTransition: Component
  const VMenuTransition: Component
  const VFabTransition: Component
  const VDialogTransition: Component
  const VDialogBottomTransition: Component
  const VFadeTransition: Component
  const VScaleTransition: Component
  const VScrollXTransition: Component
  const VScrollXReverseTransition: Component
  const VScrollYTransition: Component
  const VScrollYReverseTransition: Component
  const VSlideXTransition: Component
  const VSlideXReverseTransition: Component
  const VSlideYTransition: Component
  const VSlideYReverseTransition: Component
  const VExpandTransition: Component
  const VExpandXTransition: Component

  export default Vuetify
  export {
    colors,
    ClickOutside,
    Intersect,
    Mutate,
    Ripple,
    Resize,
    Scroll,
    Touch,
    VApp,
    VAppBar,
    VAppBarNavIcon,
    VAlert,
    VAutocomplete,
    VAvatar,
    VBadge,
    VBanner,
    VBottomNavigation,
    VBottomSheet,
    VBreadcrumbs,
    VBreadcrumbsItem,
    VBreadcrumbsDivider,
    VBtn,
    VBtnToggle,
    VCalendar,
    VCalendarDaily,
    VCalendarWeekly,
    VCalendarMonthly,
    VCard,
    VCardTitle,
    VCardSubtitle,
    VCardActions,
    VCardText,
    VCarousel,
    VCarouselItem,
    VCheckbox,
    VSimpleCheckbox,
    VChip,
    VChipGroup,
    VColorPicker,
    VColorPickerSwatches,
    VColorPickerCanvas,
    VContent,
    VCombobox,
    VCounter,
    VData,
    VDataIterator,
    VDataFooter,
    VDataTable,
    VEditDialog,
    VTableOverflow,
    VDataTableHeader,
    VSimpleTable,
    VVirtualTable,
    VDatePicker,
    VDatePickerTitle,
    VDatePickerHeader,
    VDatePickerDateTable,
    VDatePickerMonthTable,
    VDatePickerYears,
    VDialog,
    VDivider,
    VExpansionPanels,
    VExpansionPanel,
    VExpansionPanelHeader,
    VExpansionPanelContent,
    VFileInput,
    VFooter,
    VForm,
    VContainer,
    VCol,
    VRow,
    VSpacer,
    VLayout,
    VFlex,
    VHover,
    VIcon,
    VImg,
    VInput,
    VItem,
    VItemGroup,
    VLabel,
    VLazy,
    VListItemActionText,
    VListItemContent,
    VListItemTitle,
    VListItemSubtitle,
    VList,
    VListGroup,
    VListItem,
    VListItemAction,
    VListItemAvatar,
    VListItemIcon,
    VListItemGroup,
    VMenu,
    VMessages,
    VNavigationDrawer,
    VOverflowBtn,
    VOverlay,
    VPagination,
    VSheet,
    VParallax,
    VPicker,
    VProgressCircular,
    VProgressLinear,
    VRadioGroup,
    VRadio,
    VRangeSlider,
    VRating,
    VResponsive,
    VSelect,
    VSkeletonLoader,
    VSlider,
    VSlideGroup,
    VSlideItem,
    VSnackbar,
    VSparkline,
    VSpeedDial,
    VStepper,
    VStepperContent,
    VStepperStep,
    VStepperHeader,
    VStepperItems,
    VSubheader,
    VSwitch,
    VSystemBar,
    VTabs,
    VTab,
    VTabItem,
    VTabsItems,
    VTabsSlider,
    VTextarea,
    VTextField,
    VTimeline,
    VTimelineItem,
    VTimePicker,
    VTimePickerClock,
    VTimePickerTitle,
    VToolbar,
    VToolbarItems,
    VToolbarTitle,
    VTooltip,
    VTreeview,
    VTreeviewNode,
    VWindow,
    VWindowItem,
    VCarouselTransition,
    VCarouselReverseTransition,
    VTabTransition,
    VTabReverseTransition,
    VMenuTransition,
    VFabTransition,
    VDialogTransition,
    VDialogBottomTransition,
    VFadeTransition,
    VScaleTransition,
    VScrollXTransition,
    VScrollXReverseTransition,
    VScrollYTransition,
    VScrollYReverseTransition,
    VSlideXTransition,
    VSlideXReverseTransition,
    VSlideYTransition,
    VSlideYReverseTransition,
    VExpandTransition,
    VExpandXTransition,
  }
}

declare module 'vuetify/lib/directives' {
  import { DirectiveOptions } from 'vue'

  const ClickOutside: DirectiveOptions
  const Intersect: DirectiveOptions
  const Mutate: DirectiveOptions
  const Resize: DirectiveOptions
  const Ripple: DirectiveOptions
  const Scroll: DirectiveOptions
  const Touch: DirectiveOptions

  export {
    ClickOutside,
    Intersect,
    Mutate,
    Ripple,
    Resize,
    Scroll,
    Touch
  }
}
